import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Request,
  Route,
  Security,
  Tags,
} from "tsoa";
import { AppDataSource } from "../database/data-source";
import {
  CreateProfileEmployeeHonor,
  ProfileHonor,
  UpdateProfileHonor,
} from "../entities/ProfileHonor";
import HttpSuccess from "../interfaces/http-success";
import HttpStatus from "../interfaces/http-status";
import HttpError from "../interfaces/http-error";
import { ProfileHonorHistory } from "../entities/ProfileHonorHistory";
import { RequestWithUser } from "../middlewares/user";
import { ProfileEmployee } from "../entities/ProfileEmployee";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile-employee/honor")
@Tags("ProfileEmployeeHonor")
@Security("bearerAuth")
export class ProfileHonorEmployeeController extends Controller {
  private profileEmployeeRepo = AppDataSource.getRepository(ProfileEmployee);
  private honorRepo = AppDataSource.getRepository(ProfileHonor);
  private honorHistoryRepo = AppDataSource.getRepository(ProfileHonorHistory);

  @Get("user")
  public async getHonorUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileEmployeeRepo.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const record = await this.honorRepo.find({
      where: { profileEmployeeId: profile.id, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(record);
  }

  @Get("{profileEmployeeId}")
  public async getHonor(@Path() profileEmployeeId: string, @Request() req: RequestWithUser) {
    let _workflow = await new permission().Workflow(req, profileEmployeeId, "SYS_REGISTRY_EMP");
    if (_workflow == false)
      await new permission().PermissionOrgUserGet(req, "SYS_REGISTRY_EMP", profileEmployeeId);
    const record = await this.honorRepo.find({
      where: { profileEmployeeId: profileEmployeeId, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(record);
  }

  /**
   *
   * @summary ประวัติแก้ไขเกียรติประวัติ by keycloak
   *
   */
  @Get("history/user")
  public async honorHistoryUser(@Request() request: RequestWithUser) {
    const profile = await this.profileEmployeeRepo.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const record = await this.honorHistoryRepo.find({
      where: {
        histories: {
          profileEmployeeId: profile.id,
        },
      },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Get("admin/history/{honorId}")
  public async honorAdminHistory(@Path() honorId: string, @Request() req: RequestWithUser) {
    const _record = await this.honorRepo.findOneBy({ id: honorId });
    if (_record) {
      let _workflow = await new permission().Workflow(req, honorId, "SYS_REGISTRY_EMP");
      if (_workflow == false)
        await new permission().PermissionOrgUserGet(
          req,
          "SYS_REGISTRY_EMP",
          _record.profileEmployeeId,
        );
    }

    const record = await this.honorHistoryRepo.find({
      where: {
        profileHonorId: honorId,
      },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Get("history/{honorId}")
  public async honorHistory(@Path() honorId: string) {
    const record = await this.honorHistoryRepo.find({
      where: {
        profileHonorId: honorId,
      },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Post()
  public async newHonor(@Request() req: RequestWithUser, @Body() body: CreateProfileEmployeeHonor) {
    if (!body.profileEmployeeId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileEmployeeId");
    }

    const profile = await this.profileEmployeeRepo.findOneBy({ id: body.profileEmployeeId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_EMP", profile.id);
    const before = null;
    const data = new ProfileHonor();

    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileHonorHistory();
    Object.assign(history, { ...data, id: undefined });

    await this.honorRepo.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileHonorId = data.id;
    await this.honorHistoryRepo.save(history, { data: req });

    return new HttpSuccess(data.id);
  }

  @Patch("{honorId}")
  public async editHonor(
    @Request() req: RequestWithUser,
    @Body() body: UpdateProfileHonor,
    @Path() honorId: string,
  ) {
    const record = await this.honorRepo.findOneBy({ id: honorId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    await new permission().PermissionOrgUserUpdate(
      req,
      "SYS_REGISTRY_EMP",
      record.profileEmployeeId,
    );
    const before = structuredClone(record);
    const history = new ProfileHonorHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileHonorId = honorId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    this.honorRepo.save(record, { data: req });
    setLogDataDiff(req, { before, after: record });
    if (!(Object.keys(body).length === 1 && body.isUpload)) {
      this.honorHistoryRepo.save(history, { data: req });
      // setLogDataDiff(req, { before, after: history });
    }

    return new HttpSuccess();
  }

  /**
   * API ลบข้อมูลประกาศเกียรติคุณ
   * @summary API ลบข้อมูลประกาศเกียรติคุณ
   * @param honorId คีย์ประกาศเกียรติคุณ
   */
  @Patch("update-delete/{honorId}")
  public async updateIsDeleted(
    @Request() req: RequestWithUser,
    @Path() honorId: string,
  ) {
    const record = await this.honorRepo.findOneBy({ id: honorId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (record.isDeleted === true) {
      return new HttpSuccess();
    }
    await new permission().PermissionOrgUserDelete(req, "SYS_REGISTRY_EMP", record.profileEmployeeId);
    const before = structuredClone(record);
    const history = new ProfileHonorHistory();
    const now = new Date();
    record.isDeleted = true;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = now;

    Object.assign(history, { ...record, id: undefined });
    history.profileHonorId = honorId;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = now;

    await Promise.all([
      this.honorRepo.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.honorHistoryRepo.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{honorId}")
  public async deleteTraning(@Path() honorId: string, @Request() req: RequestWithUser) {
    const _record = await this.honorRepo.findOneBy({ id: honorId });
    if (_record) {
      await new permission().PermissionOrgUserDelete(
        req,
        "SYS_REGISTRY_EMP",
        _record.profileEmployeeId,
      );
    }

    await this.honorHistoryRepo.delete({
      profileHonorId: honorId,
    });

    const result = await this.honorRepo.delete({ id: honorId });

    if (result.affected == undefined || result.affected <= 0) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess();
  }
}
